<script setup lang="ts">
import { onMounted, reactive, ref } from "vue";
import { type ApiTokenIn, type ApiTokenPrivateOut } from "@/client/types.gen";
import { Modal } from "bootstrap";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import dayjs from "dayjs";
import { useUserStore } from "@/stores/users";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";

const props = defineProps<{
  modalId: string;
}>();

const tokenIn = reactive<ApiTokenIn>({
  name: "",
  expires_at: undefined,
  scopes: [],
});

const formState = reactive<{
  validated: boolean;
  loading: boolean;
}>({
  validated: false,
  loading: false,
});

const userRepository = useUserStore();
const tokenCreateForm = ref<HTMLFormElement | undefined>(undefined);
let createTokenModal: Modal | null = null;

const emit = defineEmits<{
  (e: "token-created", token: ApiTokenPrivateOut): void;
}>();

function modalClosed() {
  formState.validated = false;
}

function expiresAtTimestampChanged(target?: HTMLInputElement | null) {
  tokenIn.expires_at = target?.value ? dayjs(target?.value).unix() : undefined;
}

function createToken() {
  formState.validated = true;
  if (tokenCreateForm.value?.checkValidity()) {
    formState.loading = true;
    userRepository
      .createApiToken(tokenIn)
      .then((token) => {
        emit("token-created", token);
        createTokenModal?.hide();
        tokenIn.expires_at = undefined;
        tokenIn.name = "";
        tokenIn.scopes = [];
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

onMounted(() => {
  createTokenModal = new Modal("#" + props.modalId);
});
</script>

<template>
  <bootstrap-modal
    :modal-id="modalId"
    static-backdrop
    modal-label="Create API Token Modal"
    size-modifier-modal="lg"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header> Create personal API token</template>
    <template #body>
      <form
        id="api-token-create-form"
        ref="tokenCreateForm"
        :class="{ 'was-validated': formState.validated }"
        @submit.prevent="createToken"
      >
        <div class="mb-3">
          <label for="token-name-input" class="form-label">Token name</label>
          <input
            id="token-name-input"
            v-model="tokenIn.name"
            type="text"
            class="form-control"
            required
            minlength="3"
            maxlength="63"
            pattern="^[a-z\d\-]+$"
          />
          <div class="invalid-feedback">
            <div>
              Name must ...
              <ul>
                <li>be at least 3 Characters long</li>
                <li>contains the characters a-z 0-9 and /</li>
              </ul>
            </div>
          </div>
        </div>
        <div class="mb-3">
          <label for="expires-at-input" class="form-label"
            >Expiration date</label
          >
          <div :class="{ 'input-group': tokenIn.expires_at != undefined }">
            <input
              id="expires-at-input"
              class="form-control"
              type="date"
              :min="dayjs().add(1, 'day').format('YYYY-MM-DD')"
              :value="
                tokenIn.expires_at
                  ? dayjs.unix(tokenIn.expires_at).format('YYYY-MM-DD')
                  : undefined
              "
              @input="
                (event) =>
                  expiresAtTimestampChanged(event.target as HTMLInputElement)
              "
            />
            <div
              v-if="tokenIn.expires_at"
              class="input-group-text cursor-pointer hover-danger"
              @click="tokenIn.expires_at = undefined"
            >
              <font-awesome-icon icon="fa-solid fa-xmark" class="fs-5" />
            </div>
          </div>
        </div>
        <div class="mb-3">
          <div>Select scopes</div>
          <div class="form-check mb-2">
            <input
              id="scope-input-read"
              v-model="tokenIn.scopes"
              class="form-check-input"
              type="checkbox"
              value="read"
            />
            <label
              class="form-check-label pt-1"
              style="line-height: 0.8rem"
              for="scope-input-read"
            >
              <span>read</span>
              <br />
              <span class="text-secondary" style="font-size: 0.8rem">
                Grants read access to the CloWM API. All GET requests are
                allowed with this scope.
              </span>
            </label>
          </div>
          <div class="form-check mb-2">
            <input
              id="scope-input-write"
              v-model="tokenIn.scopes"
              class="form-check-input"
              type="checkbox"
              value="write"
            />
            <label
              class="form-check-label pt-1"
              style="line-height: 0.8rem"
              for="scope-input-write"
            >
              <span>write</span>
              <br />
              <span class="text-secondary" style="font-size: 0.8rem">
                Grants write access to the CloWM API. All POST, DELETE and PUT
                requests are allowed with this scope.
              </span>
            </label>
          </div>
        </div>
      </form>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        type="submit"
        form="api-token-create-form"
        class="btn btn-primary"
        :disabled="formState.loading || tokenIn.scopes.length === 0"
      >
        <span
          v-if="formState.loading"
          class="spinner-border spinner-border-sm"
          role="status"
          aria-hidden="true"
        ></span>
        Save
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
